/*  getvolt.c A demonstration program for use with the WinSystems GXAD Linux driver
*************************************************************************************************8
*
*	$Header$
*
*	$id$
*
*	$Log$
*/

#include <stdio.h>
#include "gxad.h"

/*  This program demonstrates the absolutely simplest way to use the LTC185X A/D
    converter on the EPX-GX2 board. It uses the full auto-ranging feature of the
	support function library to return the current voltage on an input pin. This
	function only works in single-ended mode.
*/

int main(int argc, char *argv[])
{
int channel = 0;
float value,val2;

	/* Default to channel 0, but allow a command line argument */
	
	if(argc > 1)
		channel = atoi(argv[1]);

	/* Check channel number for validity */
	
	if(channel < 0 || channel > 7)
	{
		printf("Channel numbers must be between 0 and 7 - Aborting\n");
		exit (0);
	}

	/* Here's the real deal. A single call, returns the voltage on the pin */
		
	value = (float) gxad_auto_get_channel_voltage(channel);

	/* A check for an error condition is a good idea */
	
	if(gxad_error_code)
	{
		printf("%s\n",gxad_error_string);
		exit(1);
	}	
	
	printf("Channel %d = %9.5f\n",channel,value);
}

